Index: /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoUpload/MainForm.Designer.cs	(revision 12336)
@@ -40,5 +40,5 @@
             this.cbxLstCatTo = new System.Windows.Forms.ComboBox();
             this.modelManagerBaseBindingSource = new System.Windows.Forms.BindingSource(this.components);
-            this.selectedPwgCategoryListBindingSource = new System.Windows.Forms.BindingSource(this.components);
+            this.selectedPwgAlbumListBindingSource = new System.Windows.Forms.BindingSource(this.components);
             this.label4 = new System.Windows.Forms.Label();
             this.button2 = new System.Windows.Forms.Button();
@@ -47,7 +47,15 @@
             this.tbUser = new System.Windows.Forms.TextBox();
             this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
+            this.tabControl1 = new System.Windows.Forms.TabControl();
+            this.tabPageAlbum = new System.Windows.Forms.TabPage();
+            this.tabPageImg = new System.Windows.Forms.TabPage();
+            this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
+            this.label5 = new System.Windows.Forms.Label();
             ((System.ComponentModel.ISupportInitialize)(this.modelManagerBaseBindingSource)).BeginInit();
-            ((System.ComponentModel.ISupportInitialize)(this.selectedPwgCategoryListBindingSource)).BeginInit();
+            ((System.ComponentModel.ISupportInitialize)(this.selectedPwgAlbumListBindingSource)).BeginInit();
             this.tableLayoutPanel1.SuspendLayout();
+            this.tabControl1.SuspendLayout();
+            this.tabPageAlbum.SuspendLayout();
+            this.tableLayoutPanel2.SuspendLayout();
             this.SuspendLayout();
             // 
@@ -97,6 +105,6 @@
             // 
             this.tableLayoutPanel1.SetColumnSpan(this.cbxLstCatTo, 2);
-            this.cbxLstCatTo.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.modelManagerBaseBindingSource, "PwgCategoryIdSelected", true));
-            this.cbxLstCatTo.DataSource = this.selectedPwgCategoryListBindingSource;
+            this.cbxLstCatTo.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.modelManagerBaseBindingSource, "PwgAlbumIdSelected", true));
+            this.cbxLstCatTo.DataSource = this.selectedPwgAlbumListBindingSource;
             this.cbxLstCatTo.DisplayMember = "ShowedValue";
             resources.ApplyResources(this.cbxLstCatTo, "cbxLstCatTo");
@@ -109,7 +117,7 @@
             this.modelManagerBaseBindingSource.DataSource = typeof(Com.Piwigo.Uploader.DTO.ModelManager.ModelManagerBase);
             // 
-            // selectedPwgCategoryListBindingSource
-            // 
-            this.selectedPwgCategoryListBindingSource.DataSource = typeof(Com.Piwigo.Uploader.DTO.SelectedPwgCategoryList);
+            // selectedPwgAlbumListBindingSource
+            // 
+            this.selectedPwgAlbumListBindingSource.DataSource = typeof(Com.Piwigo.Uploader.DTO.SelectedPwgAlbumList);
             // 
             // label4
@@ -166,5 +174,41 @@
             this.tableLayoutPanel1.Controls.Add(this.label3, 0, 0);
             this.tableLayoutPanel1.Controls.Add(this.cbxLstCatTo, 1, 5);
+            this.tableLayoutPanel1.Controls.Add(this.tabControl1, 4, 3);
             this.tableLayoutPanel1.Name = "tableLayoutPanel1";
+            // 
+            // tabControl1
+            // 
+            this.tabControl1.Controls.Add(this.tabPageAlbum);
+            this.tabControl1.Controls.Add(this.tabPageImg);
+            resources.ApplyResources(this.tabControl1, "tabControl1");
+            this.tabControl1.ImageList = this.imageListTV;
+            this.tabControl1.MaximumSize = new System.Drawing.Size(250, 200);
+            this.tabControl1.MinimumSize = new System.Drawing.Size(100, 200);
+            this.tabControl1.Name = "tabControl1";
+            this.tabControl1.SelectedIndex = 0;
+            // 
+            // tabPageAlbum
+            // 
+            this.tabPageAlbum.Controls.Add(this.tableLayoutPanel2);
+            resources.ApplyResources(this.tabPageAlbum, "tabPageAlbum");
+            this.tabPageAlbum.Name = "tabPageAlbum";
+            this.tabPageAlbum.UseVisualStyleBackColor = true;
+            // 
+            // tabPageImg
+            // 
+            resources.ApplyResources(this.tabPageImg, "tabPageImg");
+            this.tabPageImg.Name = "tabPageImg";
+            this.tabPageImg.UseVisualStyleBackColor = true;
+            // 
+            // tableLayoutPanel2
+            // 
+            resources.ApplyResources(this.tableLayoutPanel2, "tableLayoutPanel2");
+            this.tableLayoutPanel2.Controls.Add(this.label5, 0, 0);
+            this.tableLayoutPanel2.Name = "tableLayoutPanel2";
+            // 
+            // label5
+            // 
+            resources.ApplyResources(this.label5, "label5");
+            this.label5.Name = "label5";
             // 
             // MainForm
@@ -177,7 +221,11 @@
             this.Load += new System.EventHandler(this.MainForm_Load);
             ((System.ComponentModel.ISupportInitialize)(this.modelManagerBaseBindingSource)).EndInit();
-            ((System.ComponentModel.ISupportInitialize)(this.selectedPwgCategoryListBindingSource)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.selectedPwgAlbumListBindingSource)).EndInit();
             this.tableLayoutPanel1.ResumeLayout(false);
             this.tableLayoutPanel1.PerformLayout();
+            this.tabControl1.ResumeLayout(false);
+            this.tabPageAlbum.ResumeLayout(false);
+            this.tableLayoutPanel2.ResumeLayout(false);
+            this.tableLayoutPanel2.PerformLayout();
             this.ResumeLayout(false);
             this.PerformLayout();
@@ -200,6 +248,11 @@
         private System.Windows.Forms.Button button2;
         private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
-        private System.Windows.Forms.BindingSource selectedPwgCategoryListBindingSource;
+        private System.Windows.Forms.BindingSource selectedPwgAlbumListBindingSource;
         private System.Windows.Forms.BindingSource modelManagerBaseBindingSource;
+        private System.Windows.Forms.TabControl tabControl1;
+        private System.Windows.Forms.TabPage tabPageAlbum;
+        private System.Windows.Forms.TabPage tabPageImg;
+        private System.Windows.Forms.TableLayoutPanel tableLayoutPanel2;
+        private System.Windows.Forms.Label label5;
     }
 }
Index: /extensions/PiwigoLib/PiwigoUpload/MainForm.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/MainForm.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoUpload/MainForm.cs	(revision 12336)
@@ -17,5 +17,5 @@
         {
             InitializeComponent();
-            selectedPwgCategoryListBindingSource.DataSource = ModelManager.Instance.lstCat;
+            selectedPwgAlbumListBindingSource.DataSource = ModelManager.Instance.lstCat;
             modelManagerBaseBindingSource.DataSource = ModelManager.Instance;
         }
@@ -97,5 +97,8 @@
             try
             {
-                ServiceFactory.GetByType<Disconnect>().runService();
+                if (ModelManager.Instance.isConnected)
+                {
+                    ServiceFactory.GetByType<Disconnect>().runService();
+                }
             }
             catch (ApplicationException aex)
Index: /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoUpload/PiwigoUpload.csproj	(revision 12336)
@@ -107,5 +107,5 @@
     <None Include="app.config" />
     <None Include="Properties\DataSources\Com.Piwigo.Uploader.DTO.ModelManager+ModelManagerBase.datasource" />
-    <None Include="Properties\DataSources\Com.Piwigo.Uploader.DTO.SelectedPwgCategoryList.datasource" />
+    <None Include="Properties\DataSources\Com.Piwigo.Uploader.DTO.SelectedPwgAlbumList.datasource" />
     <None Include="Properties\Settings.settings">
       <Generator>SettingsSingleFileGenerator</Generator>
Index: /extensions/PiwigoLib/PiwigoUpload/Service/Connect.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/Connect.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/Connect.cs	(revision 12336)
@@ -22,5 +22,5 @@
             try
             {
-                List<PwgCategory> lstPCat  = null;
+                List<PwgAlbum> lstPCat  = null;
                 ModelManager.Instance.sess = PwgServiceProvider.Instance.PwgSessionService.Login( ModelManager.Instance.userName,  ModelManager.Instance.password);
                 ModelManager.Instance.isConnected = true;
@@ -28,11 +28,11 @@
                 System.Diagnostics.Debug.WriteLine("user : " + ModelManager.Instance.sess.UserName + " " + ModelManager.Instance.sess.Status);
 
-                lstPCat = PwgServiceProvider.Instance.PwgCategoriesService.GetListOfCategory(PwgCategory.RootCategoryId, true,null);
+                lstPCat = PwgServiceProvider.Instance.PwgAlbumsService.GetListOfAlbum(PwgAlbum.RootAlbumId, true,null);
 
                 ModelManager.Instance.resetLstCat();
 
-                foreach (PwgCategory item in lstPCat)
+                foreach (PwgAlbum item in lstPCat)
                 {
-                    ModelManager.Instance.lstCat.Add(new SelectedCategoryListItem() { ShowedValue = (String.IsNullOrWhiteSpace(item.Name) ? "album " + item.Id : item.Name), Id = item.Id, Data = item, isSelected = false });
+                    ModelManager.Instance.lstCat.Add(new SelectedAlbumListItem() { ShowedValue = (String.IsNullOrWhiteSpace(item.Name) ? "album " + item.Id : item.Name), Id = item.Id, Data = item, isSelected = false });
                 }
 
Index: /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/LoadFromDirectory.cs	(revision 12336)
@@ -28,4 +28,6 @@
                 img.LocalFile = fi.FullName;
                 img.Name = fi.Name;
+                img.Author = "";
+                img.AuthorComment = "";
                 album.LocalImages.Add(img);
             }
Index: /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoUpload/Service/UploadToPiwigo.cs	(revision 12336)
@@ -6,4 +6,5 @@
 using Com.Piwigo.Uploader.DTO;
 using Com.Piwigo.Lib.DTO;
+using Com.Piwigo.Lib.IService;
 
 namespace Com.Piwigo.Uploader.Service
@@ -15,19 +16,46 @@
             foreach (LocalAlbum Alb in ModelManager.Instance.lstAlbumLocaux)
             {
-                uploadAlbum(Alb, ModelManager.Instance.PwgCategoryIdSelected);
+                uploadAlbum(Alb, ModelManager.Instance.PwgAlbumIdSelected);
             } 
         }
 
-        internal static void uploadAlbum(LocalAlbum aAlbum, Int32? catId)
+        internal void uploadAlbum(LocalAlbum aAlbum, Int32? catId)
         {
-            foreach (LocalImage Img in aAlbum.LocalImages)
+            Boolean rc;
+            Int32 IdNewAlbum = 0;
+            String strMsgInfo = String.Empty;
+            rc = PwgServiceProvider.Instance.PwgAlbumsService.AddAlbum(aAlbum.Name, catId, ref  IdNewAlbum, ref strMsgInfo);
+
+            if (rc == true)
             {
-                //uploadimage();
+                aAlbum.Id = IdNewAlbum;
+
+                foreach (LocalImage Img in aAlbum.LocalImages)
+                {
+                    if (aAlbum.Id.HasValue)
+                    {
+                        Img.UpperCatId = aAlbum.Id.Value;
+                    }
+                    uploadImage(Img);
+                }
+
+                foreach (LocalAlbum Alb in aAlbum.SubAlbums)
+                {
+                    uploadAlbum(Alb, null);
+                }
             }
+            else
+            {
+                throw new ApplicationException("uploadlabum error");
+            }
+        }
 
-            foreach (LocalAlbum Alb in aAlbum.SubAlbums)
-            {
-                uploadAlbum(Alb, null);
-            }
+        internal void uploadImage(LocalImage aImg)
+        {
+            FileInfo fi = new FileInfo(aImg.LocalFile);
+
+            List<PwgTag> lstTag = new List<PwgTag>(aImg.LstTags);
+
+            PwgServiceProvider.Instance.PwgImagesService.addImageByMultiPartForm(fi, null, aImg.UpperCatId, aImg.Name, aImg.Author, aImg.AuthorComment, aImg.ConfidentialLevel, lstTag);
         }
     }
Index: /extensions/PiwigoLib/PiwigoWpf/App.xaml
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/App.xaml	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoWpf/App.xaml	(revision 12336)
@@ -8,5 +8,5 @@
         <ObjectDataProvider x:Name="ImagesODP" x:Key="Images" ObjectType="{x:Type piwigo:PwgImageListWPF}"/> <!--IsAsynchronous="True"-->
         <ObjectDataProvider x:Name="SessionODP" x:Key="Session" ObjectType="{x:Type piwigo:PwgSessionWPF}" />
-        <ObjectDataProvider x:Name="CategoriesODP" x:Key="Categories" ObjectType="{x:Type piwigo:PwgRootCategoryListWPF}"/> <!--IsAsynchronous="True"-->
+        <ObjectDataProvider x:Name="AlbumsODP" x:Key="Albums" ObjectType="{x:Type piwigo:PwgRootAlbumListWPF}"/> <!--IsAsynchronous="True"-->
         <ObjectDataProvider x:Name="TagsODP" x:Key="Tags" ObjectType="{x:Type piwigo:PwgTagListWPF}"/>
         <!--IsAsynchronous="True"-->
Index: /extensions/PiwigoLib/PiwigoWpf/App.xaml.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/App.xaml.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoWpf/App.xaml.cs	(revision 12336)
@@ -22,5 +22,5 @@
              // Model object was created in the app.xaml, so we have to link to them
             PwgModelManager.Instance.Session = (PwgSessionWPF)(this.Resources["Session"] as ObjectDataProvider).Data;
-            PwgModelManager.Instance.CategoryList = (PwgRootCategoryListWPF)(this.Resources["Categories"] as ObjectDataProvider).Data;
+            PwgModelManager.Instance.AlbumList = (PwgRootAlbumListWPF)(this.Resources["Albums"] as ObjectDataProvider).Data;
             PwgModelManager.Instance.ImageList = (PwgImageListWPF)(this.Resources["Images"] as ObjectDataProvider).Data;
             PwgModelManager.Instance.TagsList = (PwgTagListWPF)(this.Resources["Tags"] as ObjectDataProvider).Data;
Index: /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdConnect.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdConnect.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdConnect.cs	(revision 12336)
@@ -33,13 +33,13 @@
                 }
 
-                SendUiInfo("Retriving list of Category from server...");
+                SendUiInfo("Retriving list of Album from server...");
                 PwgSessionWPFHelper.AddPwgSessionInfoToPwgSessionWPF(sess, ref sesWPF);
 
-                PwgCategoryListWPFHelper.InitRootCategory();
+                PwgAlbumListWPFHelper.InitRootAlbum();
 
-                List<PwgCategory> lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetListOfCategory(null, null, null); //(PwgModelManager.Instance.Session.Status == PwgSessionStatusEnum.Guest)
-                PwgRootCategoryWPF aRootCatWPF = PwgModelManager.Instance.RootCategoryList;
+                List<PwgAlbum> lstCat = PwgServiceProvider.Instance.PwgAlbumsService.GetListOfAlbum(null, null, null); //(PwgModelManager.Instance.Session.Status == PwgSessionStatusEnum.Guest)
+                PwgRootAlbumWPF aRootCatWPF = PwgModelManager.Instance.RootAlbumList;
 
-                PwgCategoryListWPFHelper.ConvertPwgCategoryListToPwgRootCategoryWPF(lstCat, ref aRootCatWPF);
+                PwgAlbumListWPFHelper.ConvertPwgAlbumListToPwgRootAlbumWPF(lstCat, ref aRootCatWPF);
                 aRootCatWPF.IsExpanded = true;
 
Index: /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdDisconnect.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdDisconnect.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdDisconnect.cs	(revision 12336)
@@ -26,5 +26,5 @@
                 PwgSessionWPFHelper.AddPwgSessionInfoToPwgSessionWPF(sess, ref sesWPF);
 
-                SendUiInfo("Removing Image and Category ...");
+                SendUiInfo("Removing Image and Album ...");
                 if (PwgModelManager.Instance.ImageList != null)
                 {
@@ -32,13 +32,13 @@
                 }
 
-                if ((PwgModelManager.Instance.CategoryList != null)
-                    && (PwgModelManager.Instance.RootCategoryList != null))
+                if ((PwgModelManager.Instance.AlbumList != null)
+                    && (PwgModelManager.Instance.RootAlbumList != null))
                 {
-                    PwgModelManager.Instance.RootCategoryList.Childrens.Clear();
+                    PwgModelManager.Instance.RootAlbumList.Childrens.Clear();
                 }
 
-                if (PwgModelManager.Instance.CategoryList != null)
+                if (PwgModelManager.Instance.AlbumList != null)
                 {
-                    PwgModelManager.Instance.CategoryList.Clear();
+                    PwgModelManager.Instance.AlbumList.Clear();
                 }
 
Index: /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetImageforAlbum.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetImageforAlbum.cs	(revision 12336)
+++ /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetImageforAlbum.cs	(revision 12336)
@@ -0,0 +1,52 @@
+﻿using System;
+using System.Collections.Generic;
+using Com.Piwigo.Lib.IService;
+using Com.Piwigo.Wpf.DTO;
+using Com.Piwigo.Lib.DTO;
+using Com.Piwigo.Wpf.DTO.Helper;
+using Com.Piwigo.Wpf.Helper;
+using Com.Piwigo.Wpf.Service;
+
+namespace Com.Piwigo.Wpf.Command
+{
+    public sealed class PwgCmdGetImageforAlbum : AsyncCommand
+    {
+        public override string Text { get { return "Get images for a Album"; } }
+
+        protected override void OnExecute(object parameter)
+        {
+            PwgAlbumWPF catParam;
+            Int32 aPage = 0;
+            Int32 aPerPage = 0;
+            Int32 acount = 0;
+
+            try
+            {
+                Uri uriServer = new Uri(PwgModelManager.Instance.Session.ServeurName);
+                if (parameter is PwgAlbumWPF)
+                {
+                    PwgImageListWPF lstImgWPF = PwgModelManager.Instance.ImageList;
+                    SendUiInfo("Removing image...");
+                    PwgModelManager.Instance.ImageShown = null;
+                    if (lstImgWPF != null)
+                    {
+                        lstImgWPF.Clear();
+                    }
+
+                    catParam = (PwgAlbumWPF)parameter;
+                    SendUiInfo("Setting up cache data...");
+                    ImageCacheManager.Instance.SetCurrentAlbum(catParam.Id.ToString());
+
+                    SendUiInfo("Retriving images list from server...");
+                    List<PwgImage> lstImg = PwgServiceProvider.Instance.PwgAlbumsService.GetListOfImagesFormAlbum(catParam.Id, false, null, null, null, null, null, null, null, null, null, null, null, null, null, true, ref aPage, ref aPerPage, ref  acount);
+                    
+                    PwgImageListWPFHelper.ConvertPwgImageListToPwgImageListWPF(lstImg, ref lstImgWPF);
+                }
+            }
+            catch (PwgServiceException ex)
+            {
+                SendUiInfo("Error " + ex.NumeroErr + " " + ex.MessageErr);
+            }
+        }
+    }
+}
Index: /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetImageforTag.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetImageforTag.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetImageforTag.cs	(revision 12336)
@@ -36,5 +36,5 @@
                     tagParam = (PwgTagWPF)parameter;
                     SendUiInfo("Setting up cache data...");
-                    ImageCacheManager.Instance.SetCurrentCategory("Tag-" + tagParam.Name);
+                    ImageCacheManager.Instance.SetCurrentAlbum("Tag-" + tagParam.Name);
 
                     SendUiInfo("Retriving images list from server...");
Index: /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetSubAlbumforAlbum.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetSubAlbumforAlbum.cs	(revision 12336)
+++ /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdGetSubAlbumforAlbum.cs	(revision 12336)
@@ -0,0 +1,44 @@
+﻿using System;
+using System.Collections.Generic;
+using Com.Piwigo.Lib.IService;
+using Com.Piwigo.Wpf.DTO;
+using Com.Piwigo.Lib.DTO;
+using Com.Piwigo.Wpf.DTO.Helper;
+using Com.Piwigo.Wpf.Helper;
+using Com.Piwigo.Wpf.Service;
+
+namespace Com.Piwigo.Wpf.Command
+{
+    public sealed class PwgCmdGetSubAlbumforAlbum : AsyncCommand
+    {
+        public override string Text { get { return "Get sub-Albums for a Album"; } }
+
+        protected override void OnExecute(object parameter)
+        {
+            PwgAlbumWPF catParam;
+            try
+            {
+                if (parameter is PwgAlbumWPF)
+                {
+                    PwgImageListWPF lstImgWPF = PwgModelManager.Instance.ImageList;
+                    catParam = (PwgAlbumWPF)parameter;
+
+                    SendUiInfo("Retriving Album list from server...");
+                    List<PwgAlbum> lstCat = PwgServiceProvider.Instance.PwgAlbumsService.GetListOfAlbum(catParam.Id, null, null);
+                    if (catParam.Childrens == null)
+                    {
+                        catParam.Childrens = new PwgAlbumListWPF();
+                    }
+                    PwgAlbumListWPF lstCatWPF = catParam.Childrens;
+
+                    PwgAlbumListWPFHelper.ConvertPwgAlbumListToPwgAlbumListWPF(lstCat, ref lstCatWPF);
+                    catParam.IsExpanded = true;
+                }
+            }
+            catch (PwgServiceException ex)
+            {
+                SendUiInfo("Error " + ex.NumeroErr + " " + ex.MessageErr);
+            }
+        }
+    }
+}
Index: /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdProvider.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdProvider.cs	(revision 12335)
+++ /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdProvider.cs	(revision 12336)
@@ -21,9 +21,9 @@
                     objICom = PwgCmdDisconnect;
                     break;
-                case "PwgCmdGetImageforCategory":
-                    objICom = PwgCmdGetImageforCategory;
+                case "PwgCmdGetImageforAlbum":
+                    objICom = PwgCmdGetImageforAlbum;
                     break;
-                case "PwgCmdGetSubCategorieforCategory":
-                    objICom = PwgCmdGetSubCategorieforCategory;
+                case "PwgCmdGetSubAlbumforAlbum":
+                    objICom = PwgCmdGetSubAlbumforAlbum;
                     break;
                 case "PwgCmdGetImageforTag":
@@ -63,27 +63,27 @@
         }
 
-        public static AsyncCommand _pwgCmdGetImageforCategory;
-        public static AsyncCommand PwgCmdGetImageforCategory
+        public static AsyncCommand _pwgCmdGetImageforAlbum;
+        public static AsyncCommand PwgCmdGetImageforAlbum
         {
             get
             {
-                if (_pwgCmdGetImageforCategory == null)
+                if (_pwgCmdGetImageforAlbum == null)
                 {
-                    _pwgCmdGetImageforCategory = new PwgCmdGetImageforCategory();
+                    _pwgCmdGetImageforAlbum = new PwgCmdGetImageforAlbum();
                 }
-                return _pwgCmdGetImageforCategory;
+                return _pwgCmdGetImageforAlbum;
             }
         }
 
-        public static AsyncCommand _pwgCmdGetSubCategorieforCategory;
-        public static AsyncCommand PwgCmdGetSubCategorieforCategory
+        public static AsyncCommand _pwgCmdGetSubAlbumforAlbum;
+        public static AsyncCommand PwgCmdGetSubAlbumforAlbum
         {
             get
             {
-                if (_pwgCmdGetSubCategorieforCategory == null)
+                if (_pwgCmdGetSubAlbumforAlbum == null)
                 {
-                    _pwgCmdGetSubCategorieforCategory = new PwgCmdGetSubCategorieforCategory();
+                    _pwgCmdGetSubAlbumforAlbum = new PwgCmdGetSubAlbumforAlbum();
                 }
-                return _pwgCmdGetSubCategorieforCategory;
+                return _pwgCmdGetSubAlbumforAlbum;
             }
         }
Index: /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdSelectImageInAlbum.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdSelectImageInAlbum.cs	(revision 12336)
+++ /extensions/PiwigoLib/PiwigoWpf/Command/PwgCmdSelectImageInAlbum.cs	(revision 12336)
@@ -0,0 +1,39 @@
+﻿using System;
+using System.Collections.Generic;
+using Com.Piwigo.Lib.IService;
+using Com.Piwigo.Wpf.DTO;
+using Com.Piwigo.Lib.DTO;
+using Com.Piwigo.Wpf.DTO.Helper;
+using Com.Piwigo.Wpf.Helper;
+using Com.Piwigo.Wpf.Service;
+using System.Windows.Input;
+
+namespace Com.Piwigo.Wpf.Command
+{
+    public static class PwgCmdSelectImageInAlbum
+    {
+        public static DelegateCommand Command = new DelegateCommand(Execute, CanExecute);
+
+        private static void Execute(object obj)
+        {
+            foreach (PwgImageWPF imgWpf in PwgModelManager.Instance.ImageList)
+            {
+                if (imgWpf.IsSelected)
+                {
+                    PwgModelManager.Instance.ImageShown = imgWpf;
+                }                
+            }
+        }
+
+        private static bool CanExecute(object obj)
+        {
+            bool ret = false;
+
+            if (PwgModelManager.Instance.ImageList != null)
+            {
+                ret = (PwgModelManager.Instance.ImageList.Count >= 0);
+            }
+            return ret;   
+        }
+    }
+}
Index: /extensions/PiwigoLib/PiwigoWpf/DTO/Helper/PwgAlbumListWPFHelper.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoWpf/DTO/Helper/PwgAlbumListWPFHelper.cs	(revision 12336)
+++ /extensions/PiwigoLib/PiwigoWpf/DTO/Helper/PwgAlbumListWPFHelper.cs	(revision 12336)
@@ -0,0 +1,90 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using Com.Piwigo.Lib.DTO;
+
+namespace Com.Piwigo.Wpf.DTO.Helper
+{
+    public static class PwgAlbumListWPFHelper
+    {
+        public static void AddPwgAlbumToList(    PwgAlbum aPwgAlbum,
+                                                ref PwgAlbumListWPF aPwgAlbumListWPF)
+        {
+            if (aPwgAlbum != null)
+            {
+                if (aPwgAlbumListWPF == null)
+                {
+                    aPwgAlbumListWPF = new PwgAlbumListWPF();
+                }
+
+                PwgAlbumWPF pwgCat = new PwgAlbumWPF();
+                PwgAlbumWPFHelper.ConvertPwgAlbumToPwgAlbumWPF(aPwgAlbum, ref pwgCat);
+
+                aPwgAlbumListWPF.Add(pwgCat);
+            }
+        }
+
+        public static void ConvertPwgAlbumListToPwgAlbumListWPF(List<PwgAlbum> aPwgAlbumList, ref PwgAlbumListWPF aPwgAlbumListWPF)
+        {
+            if (aPwgAlbumList != null)
+            {
+                if (aPwgAlbumListWPF == null)
+                {
+                    aPwgAlbumListWPF = new PwgAlbumListWPF();
+                }
+
+                foreach (PwgAlbum pwgCat in aPwgAlbumList)
+                {
+                    AddPwgAlbumToList(pwgCat, ref aPwgAlbumListWPF);
+                }
+            }
+        }
+
+        public static void ConvertPwgAlbumListToPwgRootAlbumWPF(List<PwgAlbum> aPwgAlbumList, ref PwgRootAlbumWPF aPwgRootAlbum)
+        {
+            if (aPwgAlbumList != null)
+            {
+                if ((aPwgRootAlbum == null)
+                    || (aPwgRootAlbum.Childrens == null))
+                {
+                    throw new SystemException("The PwgAlbumListWPFHelper.InitRootAlbum must be called before calling this.");
+                }
+
+                if (aPwgRootAlbum.Childrens == null)
+                {
+                    aPwgRootAlbum.Childrens = new PwgAlbumListWPF();
+                }
+
+                PwgAlbumListWPF aPwgAlbumListWPF = aPwgRootAlbum.Childrens;
+                foreach (PwgAlbum pwgCat in aPwgAlbumList)
+                {
+                    AddPwgAlbumToList(pwgCat, ref aPwgAlbumListWPF);
+                }
+            }
+        }
+
+        public static void InitRootAlbum ()
+          {
+            if (PwgModelManager.Instance.AlbumList == null)
+            {
+                throw new SystemException("The PwgModelManager.Instance.AlbumList must be initialized from presentation tread before calling this.");
+            }
+            if (PwgModelManager.Instance.AlbumList.Count != 1)
+            {
+                PwgModelManager.Instance.AlbumList.Clear();
+                PwgRootAlbumWPF aRootAlbum = new PwgRootAlbumWPF();
+                aRootAlbum.Name = "Albums";
+                aRootAlbum.Childrens = new PwgAlbumListWPF();
+                PwgModelManager.Instance.AlbumList.Add(aRootAlbum);
+                PwgModelManager.Instance.RootAlbumList = aRootAlbum;
+            }
+
+            if (PwgModelManager.Instance.RootAlbumList == null)
+            {
+                PwgModelManager.Instance.RootAlbumList = PwgModelManager.Instance.AlbumList.ElementAtOrDefault(0);
+            }
+
+          }
+    }
+}
